package {
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.PixelSnapping;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.utils.getTimer;
	
	import org.libspark.flartoolkit.core.FLARCode;
	import org.libspark.flartoolkit.core.FLARSquare;
	import org.libspark.flartoolkit.core.param.FLARParam;
	import org.libspark.flartoolkit.core.raster.rgb.FLARRgbRaster_BitmapData;
	import org.libspark.flartoolkit.core.transmat.FLARTransMatResult;
	import org.libspark.flartoolkit.core.types.FLARDoublePoint2d;
	import org.libspark.flartoolkit.detector.FLARSingleMarkerDetector;
	import org.libspark.flartoolkit.pv3d.FLARBaseNode;
	import org.libspark.flartoolkit.pv3d.FLARCamera3D;
	import org.papervision3d.core.geom.renderables.Triangle3D;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.objects.primitives.Plane;
	import org.papervision3d.render.LazyRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;
	
	
	[SWF(width=640,height=480,frameRate=30,backgroundColor=0x0)]

	public class gihyo4 extends Sprite {
		
		private var _base:Sprite;
	
		// input	
		private var _webcam:Camera;
		private var _video:Video;
		private var _capture:Bitmap;
		
		// ar
		private var _param:FLARParam;
		private var _code:FLARCode;
		private var _raster:FLARRgbRaster_BitmapData;
		private var _detector:FLARSingleMarkerDetector;
		private var _resultMat:FLARTransMatResult = new FLARTransMatResult();
		
		// 3d
		private var _scene:Scene3D;
		private var _viewport:Viewport3D;
		private var _camera:FLARCamera3D;
		private var _renderer:LazyRenderEngine;
		private var _baseNode:FLARBaseNode;
	
		private var _dummy:Plane;
		private var _plane:Plane;
		private var _square:Shape;
		
			
		public function gihyo4() {
			var loader:URLLoader = new URLLoader();
			loader.dataFormat = URLLoaderDataFormat.BINARY;
			loader.addEventListener(Event.COMPLETE, this._onLoadParam);
			loader.load(new URLRequest('Data/camera_para.dat'));
		}
		
		private function _onLoadParam(e:Event):void {
			var loader:URLLoader = URLLoader(e.target);
			this._param = new FLARParam();
			this._param.loadARParam(ByteArray(loader.data));
			this._param.changeScreenSize(320, 240);
			
			loader = new URLLoader();
			loader.dataFormat = URLLoaderDataFormat.TEXT;
			loader.addEventListener(Event.COMPLETE, this._onLoadCode);
			loader.load(new URLRequest('Data/flarlogo.pat'));
		}
		
		private function _onLoadCode(e:Event):void {
			var loader:URLLoader = URLLoader(e.target);
			this._code = new FLARCode(16, 16);
			this._code.loadARPatt(String(loader.data));
			
			this._base = this.addChild(new Sprite()) as Sprite;
			this._base.scaleX = this._base.scaleY = 2;
			
			// ar
			this._capture = new Bitmap(new BitmapData(320, 240, false, 0), PixelSnapping.AUTO, true);
			this._base.addChild(this._capture);
			this._raster = new FLARRgbRaster_BitmapData(this._capture.bitmapData);
			this._detector = new FLARSingleMarkerDetector(this._param, this._code, 80);
//			this._detector.setContinueMode(true);
			
			this._webcam = Camera.getCamera();
			if (!this._webcam) {
				return;
			}
			this._webcam.setMode(320, 240, 30);
			this._video = new Video(320, 240);
			this._video.attachCamera(this._webcam);
			
			// debug
			this._square = this._base.addChild(new Shape()) as Shape;
			
			// 3d
			this._scene = new Scene3D();
			this._viewport = this._base.addChild(new Viewport3D(320, 240)) as Viewport3D;
			this._viewport.x -= 3;
			this._camera = new FLARCamera3D(this._param);
			this._renderer = new LazyRenderEngine(this._scene, this._camera, this._viewport);
			this._baseNode = this._scene.addChild(new FLARBaseNode()) as FLARBaseNode;
			
			this._dummy = this._baseNode.addChild(new Plane(new WireframeMaterial(0xffffff, 0.3), 120, 120, 4, 4)) as Plane;
			
			var mat:BitmapMaterial = new BitmapMaterial(this._capture.bitmapData);
			mat.doubleSided = true;
			mat.smooth = true;
			this._plane = new Plane(mat, 120, 120, 4, 4);
			this._baseNode.addChild(this._plane);

			this.addEventListener(Event.ENTER_FRAME, this._update);
		}
		
		private function _update(e:Event):void {
			this._capture.bitmapData.draw(this._video);
			if (this._detector.detectMarkerLite(this._raster, 128) && this._detector.getConfidence() > 0.5) {
				this._detector.getTransformMatrix(this._resultMat);
				this._baseNode.setTransformMatrix(this._resultMat);
				var n:int = this._plane.geometry.faces.length;
				for (var i:int = 0; i < n; i++) {
					var t:Triangle3D = this._plane.geometry.faces[i];
					var d:Triangle3D = this._dummy.geometry.faces[i];
					t.uv0.u = (d.v0.vertex3DInstance.x + 160 - 3) / 320;
					t.uv0.v = (-d.v0.vertex3DInstance.y + 120) / 240;
					t.uv1.u = (d.v1.vertex3DInstance.x + 160 - 3) / 320;
					t.uv1.v = (-d.v1.vertex3DInstance.y + 120) / 240;
					t.uv2.u = (d.v2.vertex3DInstance.x + 160 - 3) / 320;
					t.uv2.v = (-d.v2.vertex3DInstance.y + 120) / 240;
				}
				BitmapMaterial(this._plane.material).resetMapping();
				this._plane.visible = true;
				this._plane.z = (Math.sin(getTimer() / 1000) + 1) * 40;
			} else {
				this._plane.visible = false;
			}
			this._renderer.render();
		}
	}
}